# New Contributor Guide **Developers**

This document contains some useful resources for anyone wishing to contribute to the Uplink project by contributing code.

## Quick Start

1. Get a TL;DR about Satellite and Uplink from [the doc](docs/what.md)

2. Ensure you run physical and automated tests before submitting a PR for review. We work really hard to have no regressions even if a new feature may be "more important".

3. Review both open and closed [issues](https://github.com/ssatellite-im/Uplink/issues), there may be others working on a similar feature.

4. Be aware that unless you explicitly state otherwise, contributions you make to this project will be under the licensing rights of the original author's, Satellite.im's, specified license terms (to be outlined in the repository).

5. We work based off milestones, we try to avoid making any new features that are not already in the given milestone (Kinda like sprints, but instead of a set time for each milestone, we decide from the beginning loosely what we want, then pick a reasonable deadline. Then we pull in issues and estimate roughly how many hours it might take to complete). After a milestone is completed the new milestones should never make trade-offs that bring down the quality of a feature included in a previously completed milestone.

This is designed to be able to deliver releases to the community faster and on a stricter schedule whilst also preventing feature creep. It's better in our eyes to have an app that does less, perfectly than to do more with an overall "meh" feeling about it.
